"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _values = require("babel-runtime/core-js/object/values");

var _values2 = _interopRequireDefault(_values);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getRouteAction = function getRouteAction(route, state) {
  return route.match(state) ? null : route.action();
};

var getParamActions = function getParamActions(route, values, state) {
  return (0, _values2.default)(route.params).filter(function (_ref) {
    var key = _ref.key,
        selector = _ref.selector,
        stringify = _ref.stringify;

    var specValue = values[key];
    var stateValue = selector(state);

    return stringify(specValue) !== stringify(stateValue);
  }).map(function (_ref2) {
    var key = _ref2.key,
        action = _ref2.action;
    return action(values[key]);
  });
};

exports.default = function (routes, state, spec) {
  var routeAction = getRouteAction(spec.route, state);
  var paramActions = getParamActions(spec.route, spec.params, state);

  return routeAction ? [].concat((0, _toConsumableArray3.default)(paramActions), [routeAction]) : paramActions;
};