'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getRouteFromLocation = function getRouteFromLocation(routes, location) {
  return routes.find(function (route) {
    return route.locationMatch(location);
  });
};

var parseValues = function parseValues(route, values) {
  return (0, _values2.default)(route.params).filter(function (_ref) {
    var name = _ref.name;
    return name in values;
  }).map(function (_ref2) {
    var key = _ref2.key,
        name = _ref2.name,
        parse = _ref2.parse;
    return [key, parse(values[name])];
  }).reduce(_utils.createObject, {});
};

exports.default = function (routes, location) {
  var route = getRouteFromLocation(routes, location);
  var redirected = (0, _utils.redirect)(routes, route);

  if (redirected !== undefined) {
    var locationValues = route.getParamValues(location);
    var paramValues = parseValues(redirected, locationValues);

    return (0, _utils.createSpec)(redirected, paramValues);
  } else {
    return undefined;
  }
};