'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getRouteFromState = function getRouteFromState(routes, state) {
  return routes.find(function (route) {
    return route.match(state);
  });
};

var getStateValues = function getStateValues(route, state) {
  return (0, _values2.default)(route.params).map(function (_ref) {
    var key = _ref.key,
        selector = _ref.selector;
    return [key, selector(state)];
  }).reduce(_utils.createObject, {});
};

exports.default = function (routes, state) {
  var route = getRouteFromState(routes, state);
  var redirected = (0, _utils.redirect)(routes, route);

  if (redirected !== undefined) {
    var stateValues = getStateValues(redirected, state);

    return (0, _utils.createSpec)(redirected, stateValues);
  } else {
    return undefined;
  }
};