'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSpec = exports.getRoute = exports.redirect = exports.keyFilter = exports.createObject = exports.zip = exports.locationEqualsPath = exports.locationsEqual = exports.normalizeLocation = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _history = require('history');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var normalizeLocation = exports.normalizeLocation = function normalizeLocation(location) {
  return (0, _history.parsePath)((0, _history.createPath)(location));
};

var locationsEqual = exports.locationsEqual = function locationsEqual(locationA, locationB) {
  return locationA.pathname === locationB.pathname && locationA.search === locationB.search && locationA.hash === locationB.hash;
};

var locationEqualsPath = exports.locationEqualsPath = function locationEqualsPath(location, path) {
  return locationsEqual(location, (0, _history.parsePath)(path));
};

var zip = exports.zip = function zip(a, b) {
  var zipped = [];

  for (var index = 0; index < a.length && index < b.length; index++) {
    zipped.push([a[index], b[index]]);
  }

  return zipped;
};

var createObject = exports.createObject = function createObject(object, _ref) {
  var _ref2 = (0, _slicedToArray3.default)(_ref, 2),
      key = _ref2[0],
      value = _ref2[1];

  object[key] = value;
  return object;
};

var keyFilter = exports.keyFilter = function keyFilter(object, condition) {
  return (0, _keys2.default)(object).filter(condition).map(function (key) {
    return [key, object[key]];
  }).reduce(createObject, {});
};

var redirect = exports.redirect = function redirect(routes, route) {
  if (route !== undefined && route.redirect !== undefined) {
    var redirected = routes.find(function (other) {
      return other.key === route.redirect;
    });

    return redirect(routes, redirected);
  } else {
    return route;
  }
};

var getRoute = exports.getRoute = function getRoute(routes, key) {
  var route = routes.find(function (route) {
    return route.key === key;
  });

  return redirect(routes, route);
};

var createSpec = exports.createSpec = function createSpec(route) {
  var values = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var paramValues = (0, _values2.default)(route.params).map(function (_ref3) {
    var key = _ref3.key,
        notSetValue = _ref3.notSetValue;

    var value = key in values ? values[key] : notSetValue;
    return [key, value];
  }).reduce(createObject, {});

  return { route: route, params: paramValues };
};